(* ::Package:: *)

(** User Mathematica initialization file **)
(* R.H., 31Mar10, 14Mar12  *)
verbosityLevel=0;
dirJ="D:";

(* Home of most user code files -- adapt this to your directory structure *)
NBFileDir = FileNameJoin[{dirJ,"Mathematica_code"}];
AppendTo[$Path, NBFileDir];
NBFileDir = FileNameJoin[{dirJ,"Mathematica_code/LGS_Bloch"}];
AppendTo[$Path, NBFileDir];
NBFileDir = FileNameJoin[{dirJ,"Mathematica_code/Raman_SBS"}];
AppendTo[$Path, NBFileDir];
NBFileDir = FileNameJoin[{dirJ,"Mathematica_code/Optics"}];
AppendTo[$Path, NBFileDir];


(* Research directory *)
ResearchDir = FileNameJoin[{dirJ,"research"}];

(* temp data dir *)
TmpDir = FileNameJoin[{dirJ,"tmp"}];

(* Register C compiler -- set this to your C compiler, if you have one installed *)
Needs["CCompilerDriver`"]
$CCompiler={"Compiler"->CCompilerDriver`MinGWCompiler`MinGWCompiler,
"CompilerInstallation"->"D:\\Programs\\MinGW\\bin", "CompilerName" -> Automatic,
"CompileOptions"->"-O3 -ffast-math -msse2 -mfpmath=sse"};
DistributeDefinitions[$CCompiler];

(* Make some default routines standardly available (make sure RonInit.m 
is in the path set above) *)
Get["RonInit.m"];
