(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



constPhys={
kB->1.380650424*^-23, (* Boltzmann's constant [J] *)
h->6.626176*^-34, (* Planck's constant [Js] *)
hbar->6.626176*^-34/(2\[Pi]), (* h bar [Js] *)
c0->2.99792458*^8, (* vacuum speed of light [m/s] *)
\[Epsilon]0->8.854187817620*^-12, (* vaccum permittivity [As/(Vm)] *)
Z0->376.72979512339, (* vacuum impedance [Ohm] *)
gEarth->9.80665,   (* conventional standard value of g (gravity acceleration on Earth) [m/s^2]  *)
nAir->(1.0+27235.9*^-8)   (* refractive index of air from Edlen formula (589nm, 1013hPa, 20C). At 1178nm, it would be (1.0+26900.1*^-8) *)
};


(* Degrees to radian, and back -- defined as exact numbers *)
Deg2Rad=\[Pi]/180;
Rad2Deg=1/Deg2Rad;


(* Arcseconds to radian, and back *)
Rad2AS=180/\[Pi]*3600; AS2Rad=1/Rad2AS;


(* Convert Gaussian sigma to FWHM, hence for  f(x)=exp(-x^2/(2 \[Sigma]^2)) *)
\[Sigma]2FWHM=2Sqrt[2Log[2]];FWHM2\[Sigma]=1/\[Sigma]2FWHM;


(* Product of FWHM of magnitude squared Gaussian in time domain and its Fourier transform (equals 0.441...)
We use the fact that the Fourier transform of exp(-at^2) is (\[Pi]/a)^(-1/2) exp(-\[Omega]^2/(4a)) and \[Omega]=2\[Pi]f *)
ClearAll[a,\[Sigma]t,\[Sigma]t];
FWHMtFWHMfMag=\[Sigma]p*\[Sigma]t*\[Sigma]2FWHM^2/.{Solve[2 (2\[Pi])^2/4/a==1/\[Sigma]p^2/2,\[Sigma]p][[2,1]],Solve[2a==1/2/\[Sigma]t^2,\[Sigma]t][[2,1]]};


Needs["PlotLegends`"];


ClearAll[th125];ronPlotStyle=Thickness[th125];th125=0.001;ronPlotfs=12;


ronPlot[x___]:=Plot[x,Frame->True,BaseStyle->{FontFamily->"Helvetica",ronPlotfs},ImageSize->6 72,PerformanceGoal->"Quality",PlotRange->All,PlotStyle->{{Blue,ronPlotStyle},{Red,ronPlotStyle},{Darker[Green],ronPlotStyle},{Magenta,ronPlotStyle},{Cyan,ronPlotStyle},{Black,ronPlotStyle},{Yellow,ronPlotStyle},{Brown,ronPlotStyle}}];


ronLogPlot[x___]:=LogPlot[x,Frame->True,BaseStyle->{FontFamily->"Helvetica",ronPlotfs},ImageSize->6 72,PerformanceGoal->"Quality",PlotRange->All,PlotStyle->{{Blue,ronPlotStyle},{Red,ronPlotStyle},{Darker[Green],ronPlotStyle},{Magenta,ronPlotStyle},{Cyan,ronPlotStyle},{Black,ronPlotStyle},{Yellow,ronPlotStyle},{Brown,ronPlotStyle}}];
ronLogLogPlot[x___]:=LogLogPlot[x,Frame->True,BaseStyle->{FontFamily->"Helvetica",ronPlotfs},ImageSize->6 72,PerformanceGoal->"Quality",PlotRange->All,PlotStyle->{{Blue,ronPlotStyle},{Red,ronPlotStyle},{Darker[Green],ronPlotStyle},{Magenta,ronPlotStyle},{Cyan,ronPlotStyle},{Black,ronPlotStyle},{Yellow,ronPlotStyle},{Brown,ronPlotStyle}}];


ronListLinePlot[x___]:=ListLinePlot[x,Frame->True,BaseStyle->{FontFamily->"Helvetica",ronPlotfs},ImageSize->6 72,PerformanceGoal->"Quality",PlotRange->All,PlotStyle->{{Blue,ronPlotStyle},{Red,ronPlotStyle},{Darker[Green],ronPlotStyle},{Magenta,ronPlotStyle},{Cyan,ronPlotStyle},{Black,ronPlotStyle},{Yellow,ronPlotStyle},{Brown,ronPlotStyle}}];


ronListLogPlot[x___]:=ListLogPlot[x,Frame->True,BaseStyle->{FontFamily->"Helvetica",ronPlotfs},ImageSize->6 72,PerformanceGoal->"Quality",PlotRange->All,Joined->True,PlotStyle->{{Blue,ronPlotStyle},{Red,ronPlotStyle},{Darker[Green],ronPlotStyle},{Magenta,ronPlotStyle},{Cyan,ronPlotStyle},{Black,ronPlotStyle},{Yellow,ronPlotStyle},{Brown,ronPlotStyle}}];


ronListLogLogPlot[x___]:=ListLogLogPlot[x,Frame->True,BaseStyle->{FontFamily->"Helvetica",ronPlotfs},ImageSize->6 72,PerformanceGoal->"Quality",PlotRange->All,Joined->True,PlotStyle->{{Blue,ronPlotStyle},{Red,ronPlotStyle},{Darker[Green],ronPlotStyle},{Magenta,ronPlotStyle},{Cyan,ronPlotStyle},{Black,ronPlotStyle},{Yellow,ronPlotStyle},{Brown,ronPlotStyle}}];


ronListPlot[x___]:=ListPlot[x,Frame->True,BaseStyle->{FontFamily->"Helvetica",ronPlotfs},ImageSize->6 72,PerformanceGoal->"Quality",PlotRange->All,PlotStyle->{{Blue,ronPlotStyle},{Red,ronPlotStyle},{Darker[Green],ronPlotStyle},{Magenta,ronPlotStyle},{Cyan,ronPlotStyle},{Black,ronPlotStyle},{Yellow,ronPlotStyle},{Brown,ronPlotStyle}}];


ronListContourPlot[x___]:=ListContourPlot[x,InterpolationOrder->3,ImageSize->6 72,BaseStyle->{FontFamily->"Helvetica",ronPlotfs},ContourLabels->All,ColorFunction->"FruitPunchColors",PerformanceGoal->"Quality",Contours->20,PlotRange->Automatic];


(* ronPlot[{x^(1/4),x^(3/4),x^(3/2),x^(5/2),x^(5.5/2)},{x,0,2},FrameLabel->{x,y},Epilog->{Thickness[0.0002] ,Line[{{1,0},{1000,0}}]}] *)


fft[x_]:=Fourier[x,FourierParameters->{1,-1}];
ifft[x_]:=InverseFourier[x,FourierParameters->{1,-1}];


(* fft[x_]:=Module[{y=Norm[x],f1},
If[y==0.0,
x,
f1=1000.0/y;
(1.0/f1)*Fourier[f1*x,FourierParameters->{1,-1}]
]
];
ifft[x_]:=Module[{y=Norm[x],f1},
If[y==0.0,
x,
f1=1000.0/y;
(1.0/f1)*InverseFourier[f1*x,FourierParameters->{1,-1}]
]
];*)


symFFTVec[n_]:=Range[-Floor[n/2],n-1-Floor[n/2]];


fftshift[x_?VectorQ]:=
Module[{n,nh},n=Length[x];nh=Ceiling[0.5n];
Join[x[[nh+1;;n]],x[[1;;nh]]]];
ifftshift[x_?VectorQ]:=
Module[{n,nh},n=Length[x];nh=Floor[0.5n];
Join[x[[nh+1;;n]],x[[1;;nh]]]];


psd[ft_,dt_]:=Module[{n=Length[ft],df},
df=1.0/(n dt);
Transpose[{df(Range[0,n-1]-Ceiling[n/2]),(1.0/df)*fftshift[absSqr[ifft[ft]]]}]
];


absSqr[x_]:=Re[x*x\[Conjugate]];


(* absSqr= Compile[{{x, _Complex,1}}, Re[x]^2+Im[x]^2]*)


dB2ratio[dB_]:=10^(0.1dB);


ratio2dB[r_]:=10.0Log10[r];


dBkm2alpha=1.0*^-3/ratio2dB[E];


(* Lorentzian function; assumes value 1 at origin; integral yields \[Pi]*fwhm/2 *)


Lor[x_,x0_,fwhm_]:=1/(1+4((x-x0)/fwhm)^2);


Gaussian[a_,x_]:=1/(a Sqrt[\[Pi]]) Exp[-(x/a)^2]


(* Indicator Function *)


indF[z_,n_,seq_]:=If[z>seq[[n]]&&z<=seq[[n+1]],1,0]


ef[x_]:=EngineeringForm[x];


scaleVec[vec_,k_,factor_]:=Module[{vec1},vec1=vec;vec1[[All,k]]*=factor;vec1];


ronMachineNumberQ[x_]:=And@@Map[MachineNumberQ,Flatten[{x}]]


(* MATLAB's linspace() routine for convenience *)
linspace[a_,b_,n_:100]:=Range[a,b,(b-a)/(n-1)];


simpson[vec_,a_,b_]:=Module[{len,N,h,res},
len=Length[vec];
If[len<5,
Print["Simpson[]:Error:Column vector length must be at least 5 (found ",len,")"];
Abort[];
];
N=Floor[(len-1)/2];(* variable needed in Simpson's rule *)

If[N!=Ceiling[(len-1)/2] , (* len is even *)
 h=(b-a)/(2*N)*(len-2)/(len-1);
(*approximate the rest using a trapezoidal rule*)
 res=(vec[[len-1]]+vec[[len]])/2.0*(b-a)/(len-1);
,(* else length is odd,Simpson's rule alone will do *)
res=0.0;
h=(b-a)/(2.0*N);
]; (* If[] *)
(* Do not substitute'2*N+1' for'len' in the last element since this would be only right if len is odd *)
res+=h/3.0*( vec[[1]]+4.0*Total[vec[[2;;2*N;;2]]]+2.0*Total[vec[[3;;2*N-1;;2]]]+vec[[2*N+1]] )
];


smoothVector[a_,sm_:5,doPlot_:False]:=Module[{b,n,dx,c},
(* See help for Fourier->Applications->Filtering Data *)
n=Length[a];dx=1./(n-1);
b=Table[If[x<=1/2,Exp[-sm *n* x^2],Exp[-sm*n* (1.0-x)^2]],{x,0,1,dx}];
b/=Total[b];
c = InverseFourier[Fourier[a] Fourier[b]]Sqrt[n];
If[doPlot,
Print[{ListLinePlot[b,PlotRange->All],ListLinePlot[{a,c},PlotRange->All,AxesOrigin->{a[[1]],0}]}];];
c
];


ClearAll[uP,uPGdiv,uPGchar];
uP[x_?NumberQ,digits_: 3,isBytes_: False]:=Module[{m,prefixStr="fpn\[Mu]m\[VeryThinSpace]kMGT"},
(** Select the prefix (m==-1: milli, m==1: kilo, m==2: Mega, etc.) **)
m=If[!isBytes,Ceiling[Log10[Abs[x]/1000.0]/3.0],Floor[Log2[Abs[x]]/10.0]];
uPGdiv=If[!isBytes,10.0^(3 m),2.0^(10 m)]; (* divisor *)
If[m+6<1||m+6>StringLength[prefixStr],
uPGchar="";
NumberForm[x,digits]  (* return NumberForm rather than a string to preserve superscripts in powers of 10 *)
,
uPGchar=StringTake[prefixStr,{m,m}+6]; (* select prefix letter *)
(* Print["m: ",m,", prefix letter: ",uPGchar,", div: ",uPGdiv,", ",NumberForm[x/uPGdiv,digits]]; *)
ToString[NumberForm[x/uPGdiv,digits]]<>"\[VeryThinSpace]\[VeryThinSpace]\[VeryThinSpace]\[VeryThinSpace]"<>If[m==0,"",uPGchar]
]
];


rotateLeftRon[v_,nShift_:1]:=Module[{ItomegaVec,nFFT=Length[v]},
If[Mod[nShift,1]==0,
RotateLeft[v,nShift]
,
ItomegaVec=(-2.0\[Pi] I nShift/nFFT)*ifftshift[symFFTVec[nFFT]];
InverseFourier[Exp[ItomegaVec]Fourier[v]]
]
];


ClearAll[updateMFile];
updateMFile[baseName_]:=Module[{fname,sym,fnameIn},
fnameIn=StringReplace[baseName,".m"->""]<>".m";
fname=FindFile[fnameIn];
If[fname==$Failed,Print["loadMFile[]: Cannot find file ",fnameIn," in $Path, Aborting!"];Abort[]];
(** Look for a global symbol with name MYFILEwasLoaded, but remove any underscores from variable name **)
sym=Symbol[StringReplace[baseName,{"_"->"",".m"->""}]<>"wasLoaded"];
If[!(Head[sym]===Real)||AbsoluteTime[FileDate[fname]]>sym,
Get[fname];If[verbosityLevel>1,Print["Loaded file ",fname]],
If[verbosityLevel>1,Print["File ",fname," is up to date"]]
];
];


(* Needs["CUDALink`"]
ronCompilationTarget=If[CUDACCompilers[]=={},"WVM","C"] *)


(*ronCompilationTarget="C";
Check[cc1Test=Compile[ {{x}},x^2+Sin[x^2],CompilationTarget->"C"];,ronCompilationTarget="WVM"];*)


(*  Write Windows-64 bit identifier to .mx file and then load it. Errors: -1: file not found, -3: ENDCONT not found (hence possibly written by 32-bit Windows?)   *)
ClearAll[ronGetMX];
ronGetMX[fname_]:=Module[{ret},
If[$System==="Microsoft Windows (64-bit)",
ret = Run["TranslateMX "<>fname];
If[ret!=0,Print["ronGetMX[]: TranslateMX.exe reports error ",ret," on file ",fname," Aborting"]; Abort[]]; 
];
Get[fname];
];


(* Translate all .mx files in directory *)
ronTranslateMx[dir_:""]:=(If[StringLength[dir]>0,Check[SetDirectory[dir],Abort[]]];If[$System==="Microsoft Windows (64-bit)",Map[Run["TranslateMX "<>#]&,FileNames["*.mx"]]]);


(* Translate binary .mx files cross-platform on little-endian systems 
transWin64[]:=(transWin32Win64[];transLinWin64[])*)


(* Translate binary .mx files cross-platform on little-endian systems *)
ClearAll[translateMX];
translateMX[]:=Module[{strs,n,n2,i,out1},
strs={ (* Use a hex editor to read these hex strings out of the beginning of .mx files. They start after the closing bracket of the comment and end just before the string "Stage 1". Note that they all have the same string length. When converting from the old 32-bit Windows format to 64-bit formats, it's necessary to cut part of the comment in the beginnng of each .mx file in order to maintain the total file length. *)
"697468204765742E2A2900000808080800000000000020400800000057696E646F77730008000000454E44434F4E540008000000", (* Win32 *)
"2A2900000808080800000000000020400D0000004C696E75782D7838362D36340000000008000000454E44434F4E540008000000", (* Linux64, Mathematica v7 *)
"2A2900000808080800000000000020400F00000057696E646F77732D7838362D3634000008000000454E44434F4E540008000000", (* Win64 *)
"2A2900000808080800000000000020400D00000057696e646f777300362D36340000000008000000454E44434F4E540008000000",  (* Linux64 to Win32, 
old conversion*)
"2A2900000808080800000000000020400D00000057696E646F777300000000000000000008000000454E44434F4E540008000000", (* Linux64 to Win32, new version *)
"697468204765742E2A290000080808080000000000001C400800000057696E646F77730008000000454E44434F4E540008000000" (* Win32, old version(?) *)
};
n=Switch[$System,
"Microsoft Windows (32-bit)",1,
"Linux (64-bit)",2,
"Microsoft Windows (64-bit)",3
];
(*n=1;*)
If[Head[n]===Switch,Print["translateMX[]: Unknown operating system ",$System];Abort[]];
Print["n: ",n];
out1=ConstantArray[-50,Length[strs]];
(* "sfk" is the "Swiss File Knife" multi-purpose utility *)
For[i=1,i<=Length[strs],i++,
(* If Linux to Win32 *)
n2=If[i==2&&n==1,5,n];
If[i==n2,Continue[]];
(* Print["sfk replace -bin /"<>strs[[i]]<>"/"<>strs[[n]]<>"/ -dir . -file .mx -yes"]; *)
out1[[i]]=Run["\"C:\\Program Files\\bin\\sfk\" replace -bin /"<>strs[[i]]<>"/"<>strs[[n2]]<>"/ -dir . -file .mx -yes"];
Print["Code: ",out1[[i]]];
];
out1
]


(*
Run["\"C:\\Program Files\\bin\\sfk\" replace -bin /"<>"2A2900000808080800000000000020400D0000004C696E75782D7838362D36340000000008000000454E44434F4E540008000000"<>"/"<>"2A2900000808080800000000000020400D00000057696E646F777300000000000000000008000000454E44434F4E540008000000"<>"/ -dir . -file .mx -yes"];
*)



